Index: project.sample/project.inc
===================================================================
--- project.sample/project.inc	(Revision 20577)
+++ project.sample/project.inc	(Arbeitskopie)
@@ -3,6 +3,8 @@
 // This is a sample project file.
 // Modify it to suit your project.
 // Put your version in html/project/project.inc
+// add tra() around visible strings to make them translatable
+// see inc/translation.inc and http://boinc.berkeley.edu/trac/wiki/TranslateProject for Details
 
 require_once("../inc/util.inc");
 
@@ -44,12 +46,12 @@
     // If you include any links, prepend URL with $prefix
     echo "<br><hr noshade size=1><center>";
     if ($show_return) {
-        echo "<a href=".$prefix."index.php>Home</a> &middot; <a href=".$prefix."home.php>Your account</a> &middot; <a href=".$prefix."forum_index.php>Message boards</a><br>\n";
+        echo "<a href=".$prefix."index.php>".tra("Home")."</a> &middot; <a href=".$prefix."home.php>".tra("Your account")."</a> &middot; <a href=".$prefix."forum_index.php>".tra("Message boards")."</a><br>\n";
     }
-    echo "<br><br>Copyright &copy; ".date("Y ").COPYRIGHT_HOLDER."</center>\n";
+    echo "<br><br>".tra("Copyright")." &copy; ".date("Y ").COPYRIGHT_HOLDER."</center>\n";
     if ($show_date) {
         $t = time_str(time());
-        echo "<span class=\"note\">Generated $t</span>\n";
+        echo "<span class=\"note\">".tra("Generated")." $t</span>\n";
     }
 }
 
@@ -83,29 +85,23 @@
 }
 
 function show_profile_heading1() {
-    return "Your personal background.";
+    return tra("Your personal background.");
 }
 
 function show_profile_question1() {
-    return "
-        Tell us about yourself.
-        You could tell us where you're from, your age, occupation, hobbies,
-        or anything else about yourself.
-    ";
+    return tra("Tell us about yourself. You could tell us where you're from, your age, occupation, hobbies, or anything else about yourself.");
 }
 
 function show_profile_heading2() {
-    return "Your opinions about " . PROJECT;
+    return tra("Your opinions about %1", PROJECT);
 }
 
 function show_profile_question2() {
-    return "
-        Tell us your thoughts about " . PROJECT . "<ol>
-        <li>Why do you run " . PROJECT . "?
-        <li>What are your views about the project?
-        <li>Any suggestions?
-        </ol>
-    ";
+    return tra("Tell us your thoughts about %1<ol>
+    <li>Why do you run %1?
+    <li>What are your views about the project?
+    <li>Any suggestions?
+    </ol>", PROJECT);
 }
 
 function project_workunit($wu){
Index: project.sample/project_specific_prefs.inc
===================================================================
--- project.sample/project_specific_prefs.inc	(Revision 20577)
+++ project.sample/project_specific_prefs.inc	(Arbeitskopie)
@@ -44,10 +44,10 @@
     return "<option name='$name' $x>$name\n";
 }
 
-define('COLOR_DESC', 'Color scheme for graphics');
-define("MAX_GFX_CPU_PCT_DESC", "Maximum CPU % for graphics<br><span class=note>0 ... 100</span>");
-define('APP_SELECT_DESC', 'Run only the selected applications');
-define('ACCEPT_ANY_DESC', 'If no work for selected applications is available, accept work from other applications?');
+define('COLOR_DESC', tra('Color scheme for graphics'));
+define("MAX_GFX_CPU_PCT_DESC", tra("Maximum CPU % for graphics%10 ... 100%2", "<br><span class=note>", "</span>"));
+define('APP_SELECT_DESC', tra('Run only the selected applications'));
+define('ACCEPT_ANY_DESC', tra('If no work for selected applications is available, accept work from other applications?'));
 
 // The following array is for app filtering; uncomment if you want it.
 // Note: in this implementation, if a user selects all apps,
@@ -71,13 +71,13 @@
             $app_id = $app[0];
             $app_name = $app[1];
             if (in_array($app_id, $prefs->app_ids)) {
-                $x .= "$app_name: yes<br>";
+                $x .= "$app_name: ".tra("yes")."<br>";
             } else {
-                $x .= "$app_name: no<br>";
+                $x .= "$app_name: ".tra("no")."<br>";
             }
         }
     } else {
-        $x = "(all applications)";
+        $x = tra("(all applications)");
     }
     return $x;
 }