Index: user/top_hosts.php
===================================================================
--- user/top_hosts.php	(Revision 20577)
+++ user/top_hosts.php	(Arbeitskopie)
@@ -21,7 +21,6 @@
 require_once("../inc/user.inc");
 require_once("../inc/host.inc");
 require_once("../inc/boinc_db.inc");
-require_once("../inc/translation.inc");
 
 $config = get_config();
 $hosts_per_page = parse_config($config, "<hosts_per_page>");
@@ -63,7 +62,7 @@
 if ($offset % $hosts_per_page) $offset = 0;
 
 if ($offset >= ITEM_LIMIT) {
-    error_page("Limit exceeded - Sorry, first ".ITEM_LIMIT." items only");
+    error_page(tra("Limit exceeded - Sorry, first %1 items only", ITEM_LIMIT));
 }
 
 $cache_args = "sort_by=$sort_by&offset=$offset";
@@ -89,12 +88,12 @@
 echo "</table>\n<p>";
 if ($offset > 0) {
     $new_offset = $offset - $hosts_per_page;
-    echo "<a href=top_hosts.php?sort_by=$sort_by&amp;offset=$new_offset>Previous ".$hosts_per_page."</a> | ";
+    echo "<a href=top_hosts.php?sort_by=$sort_by&amp;offset=$new_offset>".tra("Previous %1", $hosts_per_page)."</a> | ";
 
 }
 if ($n==$hosts_per_page){ //If we aren't on the last page
     $new_offset = $offset + $hosts_per_page;
-    echo "<a href=top_hosts.php?sort_by=$sort_by&amp;offset=$new_offset>Next ".$hosts_per_page."</a>";
+    echo "<a href=top_hosts.php?sort_by=$sort_by&amp;offset=$new_offset>".tra("Next %1", $hosts_per_page)."</a>";
 }
 
 page_tail();
Index: user/top_teams.php
===================================================================
--- user/top_teams.php	(Revision 20577)
+++ user/top_teams.php	(Arbeitskopie)
@@ -20,7 +20,6 @@
 require_once("../inc/util.inc");
 require_once("../inc/team.inc");
 require_once("../inc/db.inc");
-require_once("../inc/translation.inc");
 
 $config = get_config();
 $teams_per_page = parse_config($config, "<teams_per_page>");
@@ -96,7 +95,7 @@
         set_cache_data(teams_to_store($data),$cache_args);
     }
 } else {
-    error_page("Limit exceeded - Sorry, first ".ITEM_LIMIT." items only");
+    error_page(tra("Limit exceeded - Sorry, first %1 items only", ITEM_LIMIT));
 }
 
 
@@ -104,7 +103,7 @@
 page_head(tra("Top %1 teams", $type_name));
 
 if (count($data) == 0) {
-    echo "There are no $type_name teams";
+    echo tra("There are no %1 teams", $type_name);
 } else {
     start_table();
     team_table_start($sort_by, $type_url);
@@ -117,12 +116,12 @@
     echo "</table>\n<p>";
     if ($offset > 0) {
         $new_offset = $offset - $teams_per_page;
-        echo "<a href=top_teams.php?sort_by=$sort_by&amp;offset=$new_offset".$type_url.">Previous ".$teams_per_page."</a> | ";
+        echo "<a href=top_teams.php?sort_by=$sort_by&amp;offset=$new_offset".$type_url.">".tra("Previous %1", $teams_per_page)."</a> | ";
 
     }
     if ($n==$teams_per_page){ //If we aren't on the last page
         $new_offset = $offset + $teams_per_page;
-        echo "<a href=top_teams.php?sort_by=$sort_by&amp;offset=$new_offset".$type_url.">Next ".$teams_per_page."</a>";
+        echo "<a href=top_teams.php?sort_by=$sort_by&amp;offset=$new_offset".$type_url.">".tra("Next %1", $teams_per_page)."</a>";
     }
 }
 page_tail();
Index: user/top_users.php
===================================================================
--- user/top_users.php	(Revision 20577)
+++ user/top_users.php	(Arbeitskopie)
@@ -20,7 +20,6 @@
 require_once("../inc/util.inc");
 require_once("../inc/user.inc");
 require_once("../inc/boinc_db.inc");
-require_once("../inc/translation.inc");
 
 $config = get_config();
 $users_per_page = parse_config($config, "<users_per_page>");
@@ -108,7 +107,7 @@
         set_cache_data(serialize($data),$cache_args);
     }
 } else {
-    error_page("Limit exceeded - Sorry, first ".ITEM_LIMIT." items only");
+    error_page(tra("Limit exceeded - Sorry, first %1 items only", ITEM_LIMIT));
 }
 
 // Now display what we've got (either gotten from cache or from DB)
@@ -123,12 +122,12 @@
 echo "</table>\n<p>";
 if ($offset > 0) {
     $new_offset = $offset - $users_per_page;
-    echo "<a href=top_users.php?sort_by=$sort_by&amp;offset=$new_offset>Previous ".$users_per_page."</a> | ";
+    echo "<a href=top_users.php?sort_by=$sort_by&amp;offset=$new_offset>".tra("Previous %1", $users_per_page)."</a> | ";
 
 }
 if ($n==$users_per_page){ //If we aren't on the last page
     $new_offset = $offset + $users_per_page;
-    echo "<a href=top_users.php?sort_by=$sort_by&amp;offset=$new_offset>Next ".$users_per_page."</a>";
+    echo "<a href=top_users.php?sort_by=$sort_by&amp;offset=$new_offset>".tra("Next %1", $users_per_page)."</a>";
 }
 
 page_tail();